// Evaluating an expression 
def eval(expr: Expr): Double = expr match {
   case Var(_) => 0    // All variables evaluate to zero
   case Number(x) => x
   case BinOp("+", e1, e2) => eval(e1) + eval(e2)
   case BinOp("*", e1, e2) => eval(e1) * eval(e2)
   case UnOp("-", e) => - eval(e)
   }

val e = BinOp("*", Number(12), UnOp("-", BinOp("+", Number(2.3), Number(3.7))))
